<?php if (!defined('PmWiki')) exit();

$RecipeInfo['Pastebin Embed']['Version'] = '2017-12-24-2';

## (:pastebin-embed:)
Markup('pastebin-embed', '<fulltext', '/\\(:pastebin-embed\\s+(.+)\\s*:\\)/', 'PastebinEmbed');

function PastebinEmbed ($m) {
	static $id = 1;
	
	$args = ParseArgs($m[1])[''];
	$paste_id = $args[0];
	$noJS = in_array('no-js', $args);
	$noFooter = in_array('nofooter', $args);
	$noLineNumbers = in_array('nolinenums', $args);
	$raw = in_array('raw', $args);
	$noPre = in_array('no-pre', $args);
	
	$embed_js_url = "https://pastebin.com/embed_js/$paste_id";
	$embed_iframe_url = "https://pastebin.com/embed_iframe/$paste_id";
	$embed_raw_url = "https://pastebin.com/raw/$paste_id";
	
	$out = "<span class='pastebin-embed-error'>Unknown error.</span>";
	
	if ($raw) {
		$raw_text = file_get_contents($embed_raw_url);
		if (!$raw_text) return Keep("<span class='pastebin-embed-error'>Could not retrieve paste!</span>");
		
		$out = $noPre ? $raw_text : Keep("<pre class='escaped' id='pastebinEmbed_$id'>\n".$raw_text."\n</pre>\n");
	} else if ($noJS) {
		include_once('simple_html_dom.php');
		
		$content_html = file_get_html($embed_iframe_url);
		if (!$content_html) return Keep("<span class='pastebin-embed-error'>Could not retrieve paste!</span>");
		$content = $content_html->find(".embedPastebin", 0);
		$content->id = "pastebinEmbed_$id";
		
		$styles_html = file_get_html($embed_js_url);
		if (!$styles_html) return Keep("<span class='pastebin-embed-error'>Could not retrieve styles!</span>");
		$styles = $styles_html->find("style", 0);
		
		$out = Keep($styles.$content);
	} else {
		$out = Keep("<script id='pastebinEmbedScript_$id' src='$embed_js_url'></script>");
	}
	
	global $HTMLStylesFmt;
	if (!$raw && $noFooter) {
		$HTMLStylesFmt['pastebin-embed'][] = "#pastebinEmbed_$id .embedFooter { display: none; }\n";
	}
	if (!$raw && $noLineNumbers) {
		$HTMLStylesFmt['pastebin-embed'][] = "#pastebinEmbed_$id > ol { padding-left: 5px; }\n";
	}
	
	$id++;
	return $out;
}

$HTMLFooterFmt[] = 
"<script>
	document.querySelectorAll('div.embedPastebin').forEach(function (embed) {
		if (embed.previousSibling.tagName == 'P') {
			embed.id = 'pastebinEmbed_' + embed.previousSibling.firstChild.id.substring(20);
		}
	});
</script>\n";
